<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMocoTrack.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMocoTrack_8cpp-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMocoTrack.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example using the MocoTrack tool with a complex model to track walking.</p>
<div class="fragment"><div class="line"><span class="comment">/* -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * OpenSim Moco: exampleMocoTrack.cpp                                         *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * Copyright (c) 2019 Stanford University and the Authors                     *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Author(s): Nicholas Bianco                                                 *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    *</span></div>
<div class="line"><span class="comment"> * not use this file except in compliance with the License. You may obtain a  *</span></div>
<div class="line"><span class="comment"> * copy of the License at http://www.apache.org/licenses/LICENSE-2.0          *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Unless required by applicable law or agreed to in writing, software        *</span></div>
<div class="line"><span class="comment"> * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          *</span></div>
<div class="line"><span class="comment"> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   *</span></div>
<div class="line"><span class="comment"> * See the License for the specific language governing permissions and        *</span></div>
<div class="line"><span class="comment"> * limitations under the License.                                             *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- */</span></div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Actuators/CoordinateActuator.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Actuators/ModelOperators.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Moco/osimMoco.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">using namespace </span><a class="code" href="namespaceOpenSim.html">OpenSim</a>;</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">void</span> torqueDrivenMarkerTracking() {</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Create and name an instance of the MocoTrack tool.</span></div>
<div class="line">    MocoTrack track;</div>
<div class="line">    track.setName(<span class="stringliteral">&quot;torque_driven_marker_tracking&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Construct a ModelProcessor and add it to the tool. ModelProcessors</span></div>
<div class="line">    <span class="comment">// accept a base model (or model file) and allow you to easily modify the</span></div>
<div class="line">    <span class="comment">// model by appending ModelOperators. Operations are performed in the order</span></div>
<div class="line">    <span class="comment">// that they are appended to the model.</span></div>
<div class="line">    ModelProcessor modelProcessor(<span class="stringliteral">&quot;subject_walk_armless.osim&quot;</span>);</div>
<div class="line">    <span class="comment">// Add ground reaction external loads in lieu of a ground-contact model.</span></div>
<div class="line">    modelProcessor.append(ModOpAddExternalLoads(<span class="stringliteral">&quot;grf_walk.xml&quot;</span>) );</div>
<div class="line">    <span class="comment">// Remove all the muscles in the model&#39;s ForceSet.</span></div>
<div class="line">    modelProcessor.append(ModOpRemoveMuscles());</div>
<div class="line">    <span class="comment">// Add CoordinateActuators to the model degrees-of-freedom. This</span></div>
<div class="line">    <span class="comment">// ignores the pelvis coordinates which already have residual</span></div>
<div class="line">    <span class="comment">// CoordinateActuators.</span></div>
<div class="line">    modelProcessor.append(ModOpAddReserves(250));</div>
<div class="line">    track.setModel(modelProcessor);</div>
<div class="line">    <span class="comment">// In C++, you could alternatively use the pipe operator &#39;|&#39; to</span></div>
<div class="line">    <span class="comment">// append ModelOperators:</span></div>
<div class="line">    <span class="comment">//   track.setModel(ModelProcessor(&quot;model.osim&quot;) | ModOpAddReserves(250));</span></div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Use this convenience function to set the MocoTrack markers reference</span></div>
<div class="line">    <span class="comment">// directly from a TRC file. By default, the marker data is filtered at</span></div>
<div class="line">    <span class="comment">//  6 Hz</span></div>
<div class="line">    track.setMarkersReferenceFromTRC(<span class="stringliteral">&quot;marker_trajectories.trc&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// There is marker data in the &#39;marker_trajectories.trc&#39; associated with</span></div>
<div class="line">    <span class="comment">// model markers that no longer exists (i.e. markers on the arms). Set this</span></div>
<div class="line">    <span class="comment">// flag to avoid an exception from being thrown.</span></div>
<div class="line">    track.set_allow_unused_references(<span class="keyword">true</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Increase the global marker tracking weight, which is the weight</span></div>
<div class="line">    <span class="comment">// associated with the internal MocoMarkerTrackingGoal term.</span></div>
<div class="line">    track.set_markers_global_tracking_weight(10);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Increase the tracking weights for individual markers in the data set </span></div>
<div class="line">    <span class="comment">// placed on bony landmarks compared to markers located on soft tissue.</span></div>
<div class="line">    MocoWeightSet markerWeights;</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;R.ASIS&quot;</span>, 20});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;L.ASIS&quot;</span>, 20});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;R.PSIS&quot;</span>, 20});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;L.PSIS&quot;</span>, 20});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;R.Knee&quot;</span>, 10});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;R.Ankle&quot;</span>, 10});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;R.Heel&quot;</span>, 10});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;R.MT5&quot;</span>, 5});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;R.Toe&quot;</span>, 2});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;L.Knee&quot;</span>, 10});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;L.Ankle&quot;</span>, 10});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;L.Heel&quot;</span>, 10});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;L.MT5&quot;</span>, 5});</div>
<div class="line">    markerWeights.cloneAndAppend({<span class="stringliteral">&quot;L.Toe&quot;</span>, 2});</div>
<div class="line">    track.set_markers_weight_set(markerWeights);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Initial time, final time, and mesh interval. The number of mesh points</span></div>
<div class="line">    <span class="comment">// used to discretize the problem is computed internally using these values.</span></div>
<div class="line">    track.set_initial_time(0.81);</div>
<div class="line">    track.set_final_time(1.65);</div>
<div class="line">    track.set_mesh_interval(0.05);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Solve! Use track.solve() to skip visualizing.</span></div>
<div class="line">    MocoSolution solution = track.solveAndVisualize();</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">void</span> muscleDrivenStateTracking() {</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Create and name an instance of the MocoTrack tool.</span></div>
<div class="line">    MocoTrack track;</div>
<div class="line">    track.setName(<span class="stringliteral">&quot;muscle_driven_state_tracking&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Construct a ModelProcessor and set it on the tool. The default</span></div>
<div class="line">    <span class="comment">// muscles in the model are replaced with optimization-friendly</span></div>
<div class="line">    <span class="comment">// DeGrooteFregly2016Muscles, and adjustments are made to the default muscle</span></div>
<div class="line">    <span class="comment">// parameters.</span></div>
<div class="line">    ModelProcessor modelProcessor(<span class="stringliteral">&quot;subject_walk_armless.osim&quot;</span>);</div>
<div class="line">    modelProcessor.append(ModOpAddExternalLoads(<span class="stringliteral">&quot;grf_walk.xml&quot;</span>));</div>
<div class="line">    modelProcessor.append(ModOpIgnoreTendonCompliance());</div>
<div class="line">    modelProcessor.append(ModOpReplaceMusclesWithDeGrooteFregly2016());</div>
<div class="line">    <span class="comment">// Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line">    modelProcessor.append(ModOpIgnorePassiveFiberForcesDGF());</div>
<div class="line">    <span class="comment">// Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line">    modelProcessor.append(ModOpScaleActiveFiberForceCurveWidthDGF(1.5));</div>
<div class="line">    track.setModel(modelProcessor);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Construct a TableProcessor of the coordinate data and pass it to the </span></div>
<div class="line">    <span class="comment">// tracking tool. TableProcessors can be used in the same way as</span></div>
<div class="line">    <span class="comment">// ModelProcessors by appending TableOperators to modify the base table.</span></div>
<div class="line">    <span class="comment">// A TableProcessor with no operators, as we have here, simply returns the</span></div>
<div class="line">    <span class="comment">// base table.</span></div>
<div class="line">    track.setStatesReference(TableProcessor(<span class="stringliteral">&quot;coordinates.sto&quot;</span>));</div>
<div class="line">    track.set_states_global_tracking_weight(10);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// This setting allows extra data columns contained in the states</span></div>
<div class="line">    <span class="comment">// reference that don&#39;t correspond to model coordinates.</span></div>
<div class="line">    track.set_allow_unused_references(<span class="keyword">true</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Since there is only coordinate position data in the states references,</span></div>
<div class="line">    <span class="comment">// this setting is enabled to fill in the missing coordinate speed data</span></div>
<div class="line">    <span class="comment">// using the derivative of splined position data.</span></div>
<div class="line">    track.set_track_reference_position_derivatives(<span class="keyword">true</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Initial time, final time, and mesh interval.</span></div>
<div class="line">    track.set_initial_time(0.81);</div>
<div class="line">    track.set_final_time(1.65);</div>
<div class="line">    track.set_mesh_interval(0.08);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Instead of calling solve(), call initialize() to receive a pre-configured</span></div>
<div class="line">    <span class="comment">// MocoStudy object based on the settings above. Use this to customize the</span></div>
<div class="line">    <span class="comment">// problem beyond the MocoTrack interface.</span></div>
<div class="line">    MocoStudy study = track.initialize();</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Get a reference to the MocoControlGoal that is added to every MocoTrack</span></div>
<div class="line">    <span class="comment">// problem by default.</span></div>
<div class="line">    MocoProblem&amp; problem = study.updProblem();</div>
<div class="line">    MocoControlGoal&amp; effort =</div>
<div class="line">        <span class="keyword">dynamic_cast&lt;</span>MocoControlGoal&amp;<span class="keyword">&gt;</span>(problem.updGoal(<span class="stringliteral">&quot;control_effort&quot;</span>));</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Put a large weight on the pelvis CoordinateActuators, which act as the</span></div>
<div class="line">    <span class="comment">// residual, or &#39;hand-of-god&#39;, forces which we would like to keep as small</span></div>
<div class="line">    <span class="comment">// as possible.</span></div>
<div class="line">     Model model = modelProcessor.process();</div>
<div class="line">     <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; coordAct : model.getComponentList&lt;CoordinateActuator&gt;()) {</div>
<div class="line">        <span class="keyword">auto</span> coordPath = coordAct.getAbsolutePathString();</div>
<div class="line">        <span class="keywordflow">if</span> (coordPath.find(<span class="stringliteral">&quot;pelvis&quot;</span>) != std::string::npos) {</div>
<div class="line">            effort.setWeightForControl(coordPath, 10);</div>
<div class="line">        }</div>
<div class="line">    }</div>
<div class="line">    </div>
<div class="line">    <span class="comment">// Solve and visualize.</span></div>
<div class="line">    MocoSolution solution = study.solve();</div>
<div class="line">    study.visualize(solution);</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Solve the torque-driven marker tracking problem.</span></div>
<div class="line">    <span class="comment">// This problem takes a few minutes to solve.</span></div>
<div class="line">    torqueDrivenMarkerTracking();</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Solve the muscle-driven state tracking problem.</span></div>
<div class="line">    <span class="comment">// This problem could take an hour or more to solve, depending on the </span></div>
<div class="line">    <span class="comment">// number of processor cores available for parallelization. With 12 cores,</span></div>
<div class="line">    <span class="comment">// it takes around 25 minutes.</span></div>
<div class="line">    muscleDrivenStateTracking();</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> EXIT_SUCCESS;</div>
<div class="line">}</div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
